
var
	STOP
	Size=32
	list
		curr
		Colors[103]
		vols = list(-28,-24,-20,-16,-12,-8,-4,0,4,8,12,16,20,24,28)
		Players = new
		PendingBans = new
		Mutes = new
		Born = new
		Stay = new
	grid[Size][Size]
	temp[Size][Size]
	Gen = 0
	mob
		Hoster
	obj
		gen
		Button
			B0
			B1
			B2
			B3
			B4
			B5
			B6
			B7
			B8

			S0
			S1
			S2
			S3
			S4
			S5
			S6
			S7
			S8

		digit
			one/D1
			two/D2
			three/D3
			four/D4
			five/D5
			six/D6
		Mute/Mute
		PlaySong/PlaySong
		StopSong/StopSong
		PauseSong/PauseSong
		RepeatSong/RepeatSong
		Vol/Vol
		Grid/Gridwork
		Rand/Rand
		Save/Save
		Load/Load
		Delete/Delete
		Back/Back
		Stop/Stop
		Start/Start
		Clear/Clear
		Step/Step
		Color/Colorizer

world
	name = "LIFE 3"
	version = 3
	hub = "Xooxer.LIFE3"
	maxx = 10
	maxy = 10

	New()
		..()

		if(!fexists("./colors.cfg"))
			world.log << ""
			world.log << "<b>FATAL ERROR!</b>"
			world.log << "Missing Colors Configuration File!"
			world.log << "Please re-download LIFE 3."
			world.log << "Shuting down..."
			world.log << ""
			shutdown()
			return
/*
		var/icon/I = new('cell.dmi')
		for(var/i=53, i<=103, i++)
			I.Blend(rgb(5,10,5),ICON_ADD)
			Colors[i] = icon(I)
		I = new('cell.dmi')
		Colors[52] += icon(I)
		for(var/i=51, i>=1, i--)
			I.Blend(rgb(5,10,5),ICON_SUBTRACT)
			Colors[i] = icon(I)
*/
		var/savefile/CLR = new("./colors.cfg")
		CLR >> Colors

		if(!Colors || !Colors.len || (Colors.len < 103))
			world.log << ""
			world.log << "<b>FATAL ERROR!</b>"
			world.log << "Corrupt Colors Configuration File!"
			world.log << "Please re-download LIFE 3."
			world.log << "Shuting down..."
			world.log << ""
			shutdown()
			return

		crban_bannedmsg = "\n> You are no longer welcome on this server.\n> Please find another, or host one yourself.\n"

		BuildGrid()
// Global:
		new/obj/Help(locate(10,1,1))
		var/obj/Life = new(locate(1,10,1))
		Life.name = "Life 3 by Xooxer"
		Life.icon = 'icon.dmi'
		Life.icon_state = "Life"
		Life.pixel_x = 4
		Life.pixel_y = -4

		gen = new(locate(7,10,1))
		gen.name = "Gen: [Gen]"
		gen.icon = 'icon.dmi'
		gen.icon_state = "Gen1"
		gen.pixel_x = -5
		var/obj/gen2 = new(locate(8,10,1))
		gen2.name = "Gen: [Gen]"
		gen2.icon = 'icon.dmi'
		gen2.icon_state = "Gen2"
		gen2.pixel_x = -5

		D1 = new(locate(9,10,1))
		D2 = new(locate(9,10,1))
		D3 = new(locate(9,10,1))
		D4 = new(locate(9,10,1))
		D5 = new(locate(9,10,1))
		D6 = new(locate(9,10,1))

// Personal:
		Mute = new(locate(1,1,1))
		PlaySong = new(locate(2,1,1))
		StopSong = new(locate(3,1,1))
		PauseSong = new(locate(2,1,1))
		RepeatSong = new(locate(3,1,1))
		Vol = new(locate(2,1,1))
		Gridwork = new(locate(8,1,1))

// Host:
		Rand = new(locate(2,10,1))
		Save = new(locate(2,10,1))
		Load = new(locate(3,10,1))
		Delete = new(locate(4,10,1))
		Back = new(locate(4,1,1))
		Stop = new(locate(5,1,1))
		Start = new(locate(5,1,1))
		Clear = new(locate(6,1,1))
		Step = new(locate(6,1,1))
		Colorizer = new(locate(9,1,1))

		var/obj/STAY = new(locate(1,8,1))
		STAY.icon = 'icon.dmi'
		STAY.icon_state = "Stay"
		S0 = new(locate(1,2,1),0,2,0,6)
		S1 = new(locate(1,2,1),1,2,0,26)
		S2 = new(locate(1,3,1),2,2,1,14)
		S3 = new(locate(1,4,1),3,2,1,2)
		S4 = new(locate(1,4,1),4,2,0,22)
		S5 = new(locate(1,5,1),5,2,0,10)
		S6 = new(locate(1,6,1),6,2,0,-2)
		S7 = new(locate(1,7,1),7,2,0,-14)
		S8 = new(locate(1,8,1),8,2,0,-26)

		var/obj/BORN = new(locate(10,8,1))
		BORN.icon = 'icon.dmi'
		BORN.icon_state = "Born"
		B0 = new(locate(10,2,1),0,1,0,6)
		B1 = new(locate(10,2,1),1,1,0,26)
		B2 = new(locate(10,3,1),2,1,0,14)
		B3 = new(locate(10,4,1),3,1,1,2)
		B4 = new(locate(10,4,1),4,1,0,22)
		B5 = new(locate(10,5,1),5,1,0,10)
		B6 = new(locate(10,6,1),6,1,0,-2)
		B7 = new(locate(10,7,1),7,1,0,-14)
		B8 = new(locate(10,8,1),8,1,0,-26)

atom
	text = ""

area
	icon = 'icon.dmi'
	icon_state = "Cover"
	name = ""

turf
	icon = 'icon.dmi'
	icon_state = "Cover"
	name = ""
	mouse_opacity = 0
	var/image/Face

	New()
		..()
		if(x!=1 && x!=10 && y!=1 && y!=10)
			Face = new(icon, src, "Grid")

