
obj
	Cell
		icon = 'cell.dmi'
		animate_movement = 0

		var
			X
			Y
			state = 0
			color = 52
			list
				Neighbors = new

		Click()
			if(Hoster != usr) return
			if(!state)
				state = 1
				flick("grow", src)
				icon_state = "alive"
			else
				state = 0
				icon_state = ""

	digit
		icon = 'icon.dmi'
		icon_state = "0"

		New()
			..()
			name = "Gen: [Gen]"

		one
			pixel_x = -5
		two
			pixel_x = 1
		three
			pixel_x = 7
		four
			pixel_x = 13
		five
			pixel_x = 19
		six
			pixel_x = 25

	Grid
		name = "Grid"
		icon = 'icon.dmi'
		icon_state = "Grid_off"
		var/image/Face

		New()
			..()
			Face = new(icon, loc, "Grid_on")

		Click()
			if(usr.Grid)
				usr.Grid = 0
				usr.client.images -= Gridwork.Face
				for(var/turf/T in block(locate(2,2,1),locate(9,9,1)))
					usr.client.images -= T.Face
			else
				usr.Grid = 1
				usr << Gridwork.Face
				for(var/turf/T in block(locate(2,2,1),locate(9,9,1)))
					usr.client.images += T.Face
			spawn() usr.SaveSettings()

	Color
		name = "Colorization Off"
		icon = 'icon.dmi'
		icon_state = "color0"
		invisibility = 100

		Click()
			if(Hoster != usr) return
			if(Hoster.Color)
				Hoster.Color = 0
				name = "Colorization Off"
				icon_state = "color0"
				for(var/obj/Cell/C in world)
					C.icon = 'cell.dmi'
					C.color = 52
			else
				Hoster.Color = 1
				name = "Colorization On"
				icon_state = "color1"
			spawn() usr.SaveSettings()

	Back
		name = "Reset Evolution"
		icon = 'icon.dmi'
		icon_state = "Back"
		pixel_x = 14
		invisibility = 100

		Click()
			if(Hoster != usr) return
			if(curr && curr.len)
				if(!STOP)
					STOP = 1
					sleep(2)
				UpdateGen(0)
				for(var/obj/Cell/C in world)
					if(curr[C.X][C.Y])
						temp[C.X][C.Y] = 1
						C.state = 1
						C.icon_state = "alive"
					else
						temp[C.X][C.Y] = 0
						C.state = 0
						C.icon_state = ""

	Stop
		name = "Stop Evolution"
		icon = 'icon.dmi'
		icon_state = "Stop"
		pixel_x = 0
		invisibility = 100

		Click()
			if(Hoster != usr) return
			STOP=1

	Start
		name = "Start Evolution"
		icon = 'icon.dmi'
		icon_state = "Start"
		pixel_x = 16
		invisibility = 100

		Click()
			if(Hoster != usr) return
			STOP = 0
			CalculateGrid(1,1)

	Clear
		name = "Clear Grid"
		icon = 'icon.dmi'
		icon_state = "Clear"
		pixel_x = -1
		invisibility = 100

		Click()
			if(Hoster != usr) return
			if(!STOP)
				STOP = 1
				sleep(2)
			if(!("untitled1" in flist("./Grids/")))
				usr.untitled = 1
				usr.gridname = "untitled[usr.untitled]"
				usr.SaveSettings()
			else
				while((usr.gridname == "untitled[usr.untitled]") && ("[usr.gridname].grd3" in flist("./Grids/")))
					usr.untitled++
					usr.gridname = "untitled[usr.untitled]"
					usr.SaveSettings()
			UpdateGen(0)
			curr = null
			for(var/obj/Cell/C in world)
				C.state = 0
				C.icon = 'cell.dmi'
				C.icon_state = ""
				C.color = 52

	Step
		name = "Step Evolution"
		icon = 'icon.dmi'
		icon_state = "Step"
		pixel_x = 17
		invisibility = 100

		Click()
			if(Hoster != usr) return
			if(!STOP)
				STOP=0
				sleep(2)
			CalculateGrid(0,1)

	Help
		icon = 'icon.dmi'
		icon_state = "Help"
		pixel_x = -4

		Click()
			usr << browse_rsc('controls.png',"controls.png")
			usr << browse('./help.html')

	Rand
		name = "Random Grid"
		icon = 'icon.dmi'
		icon_state = "Rand"
		invisibility = 100

		Click()
			if(Hoster != usr) return
			if(!STOP)
				STOP = 1
				sleep(2)
			if(!("untitled1.grd3" in flist("./Grids/")))
				usr.untitled = 1
				usr.gridname = "untitled[usr.untitled]"
				usr.SaveSettings()
			else
				while((usr.gridname == "untitled[usr.untitled]") && ("[usr.gridname].grd3" in flist("./Grids/")))
					usr.untitled++
					usr.gridname = "untitled[usr.untitled]"
					usr.SaveSettings()
			UpdateGen(0)
			curr = null
			for(var/obj/Cell/C in world)
				if(pick(1,0))
					C.state = 1
					C.icon = 'cell.dmi'
					C.icon_state = "alive"
					C.color = 52
				else
					C.state = 0
					C.icon = 'cell.dmi'
					C.icon_state = ""
					C.color = 52

	Save
		name = "Save Grid File"
		icon = 'icon.dmi'
		icon_state = "Save"
		pixel_x = 15
		invisibility = 100

		Click()
			if(Hoster != usr) return
			if(!("untitled1.grd3" in flist("./Grids/")))
				usr.untitled = 1
				usr.gridname = "untitled[usr.untitled]"
				usr.SaveSettings()
			else
				while((usr.gridname == "untitled[usr.untitled]") && ("[usr.gridname].grd3" in flist("./Grids/")))
					usr.untitled++
					usr.gridname = "untitled[usr.untitled]"
					usr.SaveSettings()
			var/newname = input("What would you like to call this grid?", "Save Grid File", usr.gridname) as text | null
			if(!newname)
				return
			if(name == " ")
				alert("Please enter a valid file name.", "Invalid File Name")
				return
			if(newname == "untitled[usr.untitled]")
				usr.gridname = "untitled[usr.untitled]"
				usr.SaveSettings()
			var/BORN = ""
			for(var/b in Born)
				BORN += "[b]"
			var/STAY = ""
			for(var/s in Stay)
				STAY += "[s]"
			if("[newname]_[STAY]-[BORN].grd3" in flist("./Grids/"))
				switch(alert("That file already exists. Overwrite?", "Overwrite File","Yes","No"))
					if("No") return
			usr.gridname = newname
			if(!curr)
				curr = new(Size,Size)
				var/Y = 0
				while(++Y <= Size)
					var/X = 0
					while(++X <= Size)
						var/obj/Cell/C = grid[X][Y]
						if(C.state)
							curr[X][Y] = 1
			var/savefile/S = new("./Grids/[usr.gridname]_[STAY]-[BORN].grd3")
			S["curr"] << curr
			S["Born"] << Born
			S["Stay"] << Stay
			alert("Saved Grid File [usr.gridname] using the [STAY]/[BORN] Ruleset.", "Grid File Saved")

	Load
		name = "Load Grid File"
		icon = 'icon.dmi'
		icon_state = "Load"
		pixel_x = -0
		invisibility = 100

		Click()
			if(Hoster != usr) return
			var/list/grids = new
			for(var/grid in flist("./Grids/")-"Grids/")
				grids += grid
			if(grids.len)
				var/g = input("Which grid would you like to load?", "Load Grid") as null | anything in grids
				if(g)
					var/savefile/S = new("./Grids/[g]")
					if(!STOP)
						STOP = 1
						sleep(2)
					S["curr"] >> curr
					S["Born"] >> Born
					S["Stay"] >> Stay
					var/list/born_buttons = list(B1,B2,B3,B4,B5,B6,B7,B8)
					var/list/stay_buttons = list(S1,S2,S3,S4,S5,S6,S7,S8)
					for(var/obj/Button/BORN in born_buttons)
						if(BORN.number in Born)
							BORN.icon_state = "button_on"
							BORN.state = 1
						else
							BORN.icon_state = "button_off"
							BORN.state = 0
					for(var/obj/Button/STAY in stay_buttons)
						if(STAY.number in Stay)
							STAY.icon_state = "button_on"
							STAY.state = 1
						else
							STAY.icon_state = "button_off"
							STAY.state = 0
					UpdateGen(0)
					for(var/obj/Cell/C in world)
						if(curr[C.X][C.Y])
							temp[C.X][C.Y] = 1
							C.state = 1
							C.icon_state = "alive"
						else
							temp[C.X][C.Y] = 0
							C.state = 0
							C.icon_state = ""
					alert("Loaded Grid File [g].", "Loaded Grid File")
			else
				alert("You have no saved grid files.", "No Grid Files Found")

	Delete
		name = "Delete Grid File"
		icon = 'icon.dmi'
		icon_state = "Delete"
		pixel_x = -11
		invisibility = 100

		Click()
			if(Hoster != usr) return
			var/list/grids = new
			for(var/grid in flist("./Grids/")-"Grids/")
				grids += grid
			if(grids.len)
				var/g = input("Which grid would you like to delete?", "Delete Grid") as null | anything in grids
				if(g)
					switch(alert("Are you sure you want to permanently remove this grid file from your computer?","Confirm Delete","Yes","No"))
						if("No") return
					fdel("./Grids/[g]")
					alert("Deleted Grid File [g].", "Deleted Grid File")
			else
				alert("You have no saved grid files.", "No Grid Files Found")

	Button
		name = "Rule Modifier"
		icon = 'icon.dmi'
		icon_state = "button_off"
		var
			number
			rule
			state

		New(Loc,Num,Rule,State,Y)
			..()
			number = Num
			rule = Rule
			state = State
			pixel_y = Y
			if(state)
				icon_state = "button_on"
			if(rule==1)
				if(!(number in Born) && State)
					Born += number
			else
				if(!(number in Stay) && State)
					Stay += number
			spawn(1)
				var/obj/O = new(Loc)
				O.icon = 'icon.dmi'
				O.icon_state = "[number]"
				O.name = ""
				O.pixel_x = 8
				O.pixel_y = pixel_y
				O.mouse_opacity = 0

		Click()
			if(Hoster != usr) return
			if(state)
				state = 0
				icon_state = "button_off"
				if(rule==1)
					if(number in Born)
						Born -= number
				else
					if(number in Stay)
						Stay -= number
			else
				state = 1
				icon_state = "button_on"
				if(rule==1)
					if(!(number in Born))
						Born += number
				else
					if(!(number in Stay))
						Stay += number

