
mob
	layer = 1

	var
		Host = 0
		mute = 0
		Repeat = 1
		Grid = 1
		Color = 1
		Muted = 0
		Paused = 0
		Volume = 50
		Position = 50
		untitled = 1
		gridname = "untitled1"
		sound
			Song
		image
			Slider

	Login()
		if(ckey in PendingBans)
			src << crban_bannedmsg
			crban_fullban(src)
			return
		..()
		if(client)
			var/save_file = client.Import()
			if(save_file)
				var/savefile/S = new(save_file)
				S["Repeat"]   >> Repeat
				S["Grid"]     >> Grid
				S["Muted"]    >> Muted
				S["Volume"]   >> Volume
				S["Color"]    >> Color
				S["gridname"] >> gridname
				S["untitled"] >> untitled

			if(Grid)
				src << Gridwork.Face
				for(var/turf/T in block(locate(2,2,1),locate(9,9,1)))
					src << T.Face
			if(Repeat)
				src << RepeatSong.Face
			if(Muted)
				src << Mute.Face
			Slider = new('icon.dmi',locate(2,1,1),"slider",15)
			Position = round(Volume/100*15,1)
			if(!Position) Position = 1
			Slider.pixel_x = vols[Position]
			src << Slider

			Players += key
			src << ""
			src << "<center><b><font size=\"4\" color=\"#00FF00\">Welcome to &nbsp; L I F E &nbsp; 3!</font></b>"
			src << "<center>An interactive demonstration in Cellular Automata."
			src << "<center><font color=\"#009900\">Based on John Conway's The Game of Life.</font>"
			src << "<center><font color=\"#007700\">Created for the BYOND Community by Xooxer</font>"
			src << "<center><font color=\"#005500\">Copyright 2006 Andrew \"Xooxer\" Arnold</font>"
			src << ""
			src << ""
			src << "<center><font color=\"#009900\">Thankfully protected by <a style=\"color: #00FF00;\" href=\"http://developer.byond.com/hub/Crispy/FullBan\">Crispy's FullBan!</a></font>"
			src << ""
			src << ""
			world << "<b>>> [name] has logged in.</b>"
			if(!Hoster && isHost(client))
				Hoster = src
				Host = 1
				Players[key] = "Host"
				src << "> You are the host."
				verbs += /mob/host/verb/Mute
				verbs += /mob/host/verb/Voice
				verbs += /mob/host/verb/Kick
				verbs += /mob/host/verb/Ban
				verbs += /mob/host/verb/Unban

				if(Color)
					Colorizer.name = "Colorization On"
					Colorizer.icon_state = "color1"
				else
					Colorizer.name = "Colorization Off"
					Colorizer.icon_state = "color0"

				src.see_invisible = 101

				if(!save_file)
					src << ""
					src << "> This appears to be your first time running LIFE 3."
					src << "> You may find it best to start with the Help File first."
					src << "> Here you will find detailed information regarding LIFE 3."
					src << "<<--- Click HELP to Begin"
					src << ""

					if(fexists("./Grids/life3_23-3.grd3"))
						var/savefile/S = new("./Grids/life3_23-3.grd3")
						S["curr"] >> curr
						for(var/obj/Cell/C in world)
							if(curr[C.X][C.Y])
								temp[C.X][C.Y] = 1
								C.state = 1
								C.icon_state = "alive"
							else
								temp[C.X][C.Y] = 0
								C.state = 0
								C.icon_state = ""

	Logout()
		world << "<b>>> [name] has logged out."
		del(src)

	Del()
		Players -= key
		..()

	Stat()
		statpanel("Who", "\[CPU\]", world.cpu)
		for(var/P in Players)
			statpanel("Who", P, Players[P])

	verb
		say(msg as text)
			set name = ">"
			set hidden = 1
			if(!msg) return
			if(length(msg) > 512) msg = copytext(msg, 1, 513)
			if(spam_timer(msg)) return
			if(mute)
				usr << "<b>[name]</b>:   [html_encode(msg)]"
			else
				world << "<b>[name]</b>:   [html_encode(msg)]"

		echo_say(msg as text)
			set name = "say"
			set hidden = 1
			say(msg)

	proc
		SaveSettings()
			var/savefile/S = new()
			S["Repeat"]   << Repeat
			S["Grid"]     << Grid
			S["Muted"]    << Muted
			S["Volume"]   << Volume
			S["Color"]    << Color
			S["gridname"] << gridname
			S["untitled"] << untitled
			client.Export(S)

