
proc
	isHost(client/C)
		if(!C) return 0
		if(!C.address || C.address == "127.0.0.1")
			return 1
		else
			return 0

	BuildGrid()
		var
			n = 0
			Y = 0
		while(++Y <= Size)
			if(++n > 4) n = 1
			var
				i = 0
				X = 0
			while(++X <= Size)
				if(++i > 4) i = 1
				var/obj/Cell/C = new(locate(round((X + 1)/4, 1)+1, round((Y + 1)/4, 1)+1, 1))
				C.pixel_x = (i-1)*8
				C.pixel_y = (n-1)*8
				C.X = X
				C.Y = Y
				C.name = "([C.X],[C.Y])"
				grid[X][Y] = C
				temp[X][Y] = 0
		Y = 0
		while(++Y <= Size)
			var/X = 0
			while(++X <= Size)
				var
					obj/Cell/C = grid[X][Y]
					I = -2
				while(++I <= 1)
					var/U = -2
					while(++U <= 1)
						if(!I && !U)
							continue
						var
							tempX = X+I
							tempY = Y+U
						if(tempX < 1)
							tempX = Size
						else if(tempX > Size)
							tempX = 1
						if(tempY < 1)
							tempY = Size
						else if(tempY > Size)
							tempY = 1
						var/obj/Cell/N = grid[tempX][tempY]
						C.Neighbors += N

	CalculateGrid(Cont, Start)
		var
			X = Size+1
			Y = Size+1
			neighbors = 0
			obj/Cell/C
		if(Start)
			curr = new(Size,Size)
		while(--Y > 0)
			X = Size+1
			while(--X > 0)
				neighbors = 0
				C = grid[X][Y]
				if(Start && C.state)
					curr[X][Y] = 1
				for(var/obj/Cell/N in C.Neighbors)
					neighbors += N.state
				if(C.state)
					if(neighbors in Stay)
						temp[X][Y] = 1
						continue
				if(neighbors in Born)
					temp[X][Y] = 1
					continue
				temp[X][Y] = 0
		UpdateGrid(Cont)

	UpdateGrid(Cont)
		var
			Y = Size+1
			X = Size+1
			alldead = TRUE
			obj/Cell/C
		while(--Y > 0)
			X = Size+1
			while(--X > 0)
				C = grid[X][Y]
				if(temp[X][Y])
					alldead = FALSE
					if(!C.state)
						C.state = 1
						flick("grow", C)
						C.icon_state = "alive"
						if(Hoster && Hoster.Color)
							if(pick(1, 0))
								if(++C.color >= 104)
									C.color = 103
								C.icon = Colors[C.color]
								continue
							else if(pick(1, 0))
								if(--C.color <= 0)
									C.color = 1
								C.icon = Colors[C.color]
								continue
				else if(C.state)
					C.state = 0
					C.icon_state = ""
		UpdateGen(++Gen)
		if(STOP || alldead)
			return
		if(Cont)
			spawn(1)
				CalculateGrid(1)

	UpdateGen(NewGen)
		Gen = NewGen
		var/TempGen = Gen,Done=0,Dtwo=0,Dthree=0,Dfour=0,Dfive=0,Dsix=0
		if(TempGen >= 100000)
			Done = round(TempGen/100000)
			TempGen -= Done*100000
		if(TempGen >= 10000)
			Dtwo = round(TempGen/10000)
			TempGen -= Dtwo*10000
		if(TempGen >= 1000)
			Dthree = round(TempGen/1000)
			TempGen -= Dthree*1000
		if(TempGen >= 100)
			Dfour = round(TempGen/100)
			TempGen -= Dfour*100
		if(TempGen >= 10)
			Dfive = round(TempGen/10)
			TempGen -= Dfive*10
		if(TempGen >= 1)
			Dsix = TempGen

		D1.icon_state = "[Done]"
		D2.icon_state = "[Dtwo]"
		D3.icon_state = "[Dthree]"
		D4.icon_state = "[Dfour]"
		D5.icon_state = "[Dfive]"
		D6.icon_state = "[Dsix]"

		gen.name = "Gen: [Gen]"
		D1.name  = "Gen: [Gen]"
		D2.name  = "Gen: [Gen]"
		D3.name  = "Gen: [Gen]"
		D4.name  = "Gen: [Gen]"
		D5.name  = "Gen: [Gen]"
		D6.name  = "Gen: [Gen]"

