
mob
	host
		verb
			Mute(trg as text|null)
				set category = "Host"
				if(!ckey(trg)) return
				if(ckey(trg) == ckey) return
				if(ckey(trg) in Mutes)
					usr << "> [trg] is already muted."
					return
				for(var/mob/M in world)
					if(M.ckey == ckey(trg))
						Players[M.key] = "Mute"
						M.mute = 1
						break
				world << "<b>>> [trg] has been muted.</b>"
				Mutes += ckey(trg)

			Voice(trg as text|null)
				set category = "Host"
				if(!ckey(trg)) return
				if(ckey(trg) == ckey) return
				if(!(ckey(trg) in Mutes))
					usr << "> [trg] is not muted."
					return
				for(var/mob/M in world)
					if(M.ckey == ckey(trg))
						Players[M.key] = null
						M.mute = 0
						break
				world << "<b>>> [trg] has been voiced.</b>"
				Mutes -= trg

			Kick(trg as text|null)
				set category = "Host"
				if(!ckey(trg)) return
				if(ckey(trg) == ckey) return
				for(var/mob/M in world)
					if(M.ckey == ckey(trg))
						world << "<b>>> [M.name] has been kicked.</b>"
						del(M)

			Ban(trg as text|null)
				set category = "Host"
				if(!ckey(trg)) return
				if(ckey(trg) == ckey) return
				if(crban_isbanned(ckey(trg)))
					usr << "> [trg] is already banned."
					return
				var/mob/M
				for(M in world)
					if(M.ckey == ckey(trg))
						M << crban_bannedmsg
						crban_fullban(M)
				if(!M) PendingBans += ckey(trg)
				world << "<b>>> [trg] has been banned.</b>"

			Unban(trg as text|null)
				set category = "Host"
				if(!ckey(trg))
					usr << "> Usage: /Unban \"Name\""
					if(crban_keylist.len)
						usr << "> Currently Banned:"
						for(var/Troll in crban_keylist)
							usr << ">	[crban_keylist[Troll]] - [Troll]"
					else
						usr << "> No players have been banned."
					return
				if(ckey(trg) == ckey) return
				if(!crban_isbanned(ckey(trg)))
					usr << "> [trg] is not banned."
					return
				crban_unban(trg)
				world << "<b>>> [trg] has been unbanned.</b>"

var
	max_msgs = 5
	flood_limit = 3
	spam_limit = 3
	min_delay = 20

mob
	var
		list/msgs
		flood_num = 0
		spam_flag = 0
		spam_num = 0

proc
	stack(var/list/L, var/item, var/list_len)
		if(!L) L = new()
		if(!L.len)
			L += item
			return L
		if(L.len < list_len)
			L += item
			return L
		var/list/L2[list_len]
		for(var/i = 2, i <= list_len, i++)
			L2[i-1] = L[i]
		L2[list_len] = item
		return L2

mob
	proc
		spam_timer(T)
			if((++spam_num) > max_msgs) spam_flag++
			if(T)
				if(!msgs) msgs = new
				if(T in msgs)
					if((++flood_num) >= flood_limit)
						if(Host)
							flood_num = 0
							msgs.len = 0
							alert("You're Spamming. I think they get the meesage!")
							return 1
						else
							flood_num = 0
							msgs.len = 0
							Mutes += ckey(name)
							world <<"<b>>> [name] has been muted.</b>"
							return 1
					msgs = stack(msgs, T, 5)
				else
					if(flood_num) flood_num--
					msgs = stack(msgs, T, 5)
			if(spam_flag > spam_limit)
				if(Host)
					spam_flag = 0
					spam_num = 0
					alert("You're flooding. Slow down!")
					return 1
				else
					spam_flag = 0
					spam_num = 0
					Mutes += ckey(name)
					world <<"<b>>> [name] has been muted.</b>"
					return 1
			spawn(min_delay)
				if(spam_num) spam_num--
				if((!spam_num) && (spam_flag)) spam_flag--
			return 0

